<?php
/**
 * Listado de Sitios
 *
 * @package Listados
 */

require_once('clases/base_datos.php');
require_once('clases/mostrar_listado.php');

/**
 * Clase Listado_Sitios
 *
 * @package Listados
 */
class Listado_Sitios {

	public $arreglo;

	/**
	 * Constructor
	 */
	public function __construct() {
		$this->arreglo = false;
	} // constructor

	/**
	 * Consultar
	 * @return boolean
	 */
	public function consultar() {
		// CONSULTAR
		$base_datos = new BD_Motor();
		try {
			$consulta = $base_datos->comando("SELECT nombre, url, notas 
				FROM sitios ORDER BY nombre ASC");
		} catch (Exception $e) {
			throw new Exception("<b>Error:</b> Al consultar los sitios. ".$e->getMessage());
		}
		$this->arreglo = $consulta->obtener_todos_los_registros();
		// ENTREGAR VERDADERO
		return true;
	}

	/**
	 * Listado
	 * @return string html
	 */
	public function listado() {
		// VALIDAR QUE HAYA QUE MOSTRAR
		if ($this->arreglo === false) {
			return "<b>Error:</b> No se ha hecho la consulta.";
		} elseif (!count($this->arreglo)) {
			return "<b>Aviso:</b> La consulta no entregó resultados.";
		}
		// ELABORAR LISTADO
		$tabla              = new Mostrar_Listado();
		$tabla->encabezados = array('Nombre', 'URL', 'Notas');
		$tabla->contenido   = $this->arreglo;
		// ENTREGAR
		return $tabla->html();
	}

} // clase Listado_Miembros

?>
